> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Refund a credit memo

POST https://rest.test.zuora.com/v1/credit-memos/{creditMemoKey}/refund
Content-Type: application/json

**Note:** This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. 

Refunds a full or partial posted credit memo to your customers. Only the amount of unapplied part could be refunded. 

You can refund a credit memo only if you have the user permission. See [Billing Roles](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/A_Administrator_Settings/User_Roles/d_Billing_Roles) for more information.

When you refund a credit memo, the total number of credit memo items to be refunded must be less than or equal to 15,000.

For a use case of this operation, see [Refund processing](https://developer.zuora.com/rest-api/general-concepts/authentication//#Refund-processing).


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/credit-memos/post-refund-credit-memo

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `creditMemoKey` (string, required) — The ID or number of the credit memo. For example, 2c92c8955bd63cc1015bd7c151af02ab or CM00000001.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a PostNonRefRefundType.

- `totalAmount` (double, required) — The total amount of the refund. The amount cannot exceed the unapplied amount of the associated credit memo. If the original credit memo was applied to one or more invoices or debit memos, you have to unapply a full or partial credit memo from the invoices or debit memos, and then refund the full or partial unapplied credit memo to your customers.
- `type` (enum, required) — The type of the refund.
  - Allowed values: `External`, `Electronic`
- `comment` (string, optional) — Comments about the refund.
- `customRates` (list of CreditMemoFromChargeCustomRatesType, optional) — It contains Home currency and Reporting currency custom rates currencies. The maximum number of items is 2 (you can pass the Home currency item, Reporting currency item, or both). **Note**: - This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `224.0` or a later version. - You cannot set the custom rates, if both the **Automatically include additional Currency Conversion information in data source exports** option and **Fx data** feature are enabled.
- `financeInformation` (PostNonRefRefundTypeFinanceInformation, optional) — Container for the finance information related to the refund.
- `gatewayId` (string, optional) — The ID of the gateway instance that processes the refund. This field can be specified only for electronic refunds. The ID must be a valid gateway instance ID, and this gateway must support the specific payment method. If no gateway ID is specified, the default gateway in the billing account configuration will be used. If no gateway is specified in the billing account, the default gateway of the corresponding tenant will be used.
- `gatewayOptions` (PostNonRefRefundTypeGatewayOptions, optional) — The field used to pass gateway-specific parameters and parameter values.
- `items` (list of RefundCreditMemoItemType, optional) — Container for credit memo items. The maximum number of items is 1,000. **Note:** This field is only available if you have the [Invoice Item Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/C_Invoice_Item_Settlement) feature enabled. Invoice Item Settlement must be used together with other Invoice Settlement features (Unapplied Payments, and Credit and Debit memos). If you wish to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information.
- `methodType` (enum, optional) — How an external refund was issued to a customer. This field is required for an external refund and must be left empty for an electronic refund. You can issue an external refund on a credit memo.
  - Allowed values: `ACH`, `Cash`, `Check`, `CreditCard`, `PayPal`, `WireTransfer`, `DebitCard`, `CreditCardReferenceTransaction`, `BankTransfer`, `Other`
- `paymentMethodId` (string, optional) — The ID of the payment method used for the refund. This field is required for an electronic refund, and the value must be an electronic payment method ID. This field must be left empty for an external refund.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code.
- `referenceId` (string, optional) — The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.
- `refundDate` (date, optional) — The date when the refund takes effect, in `yyyy-mm-dd` format. The date of the refund cannot be before the credit memo date. Specify this field only for external refunds. Zuora automatically generates this field for electronic refunds.
- `secondRefundReferenceId` (string, optional) — The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments.
- `softDescriptor` (string, optional) — A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.
- `softDescriptorPhone` (string, optional) — A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Origin__NS` (string, optional) — Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SynctoNetSuite__NS` (string, optional) — Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

## Response

### 200

OK

- `accountId` (string, optional) — The ID of the account associated with this refund. Zuora associates the refund automatically with the account from the associated payment.
- `amount` (double, optional) — The total amount of the refund.
- `cancelledOn` (string, optional, nullable) — The date and time when the refund was cancelled, in `yyyy-mm-dd hh:mm:ss` format.
- `comment` (string, optional, nullable) — Comments about the refund.
- `createdById` (string, optional) — The ID of the Zuora user who created the refund.
- `createdDate` (string, optional) — The date and time when the refund was created, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-06 15:31:10.
- `creditMemoId` (string, optional) — The ID of the credit memo that is refunded.
- `financeInformation` (GetRefundCreditMemoTypeFinanceInformation, optional) — Container for the finance information related to the refund.
- `gatewayId` (string, optional) — The ID of the gateway instance that processes the refund.
- `gatewayResponse` (string, optional) — The message returned from the payment gateway for the refund. This message is gateway-dependent.
- `gatewayResponseCode` (string, optional) — The response code returned from the payment gateway for the refund. This code is gateway-dependent.
- `gatewayState` (enum, optional) — The status of the refund in the gateway.
  - Allowed values: `MarkedForSubmission`, `Submitted`, `Settled`, `NotSubmitted`, `FailedToSettle`
- `id` (string, optional) — The ID of the created refund.
- `markedForSubmissionOn` (string, optional, nullable) — The date and time when a refund was marked and waiting for batch submission to the payment process, in `yyyy-mm-dd hh:mm:ss` format.
- `methodType` (enum, optional) — How an external refund was issued to a customer.
  - Allowed values: `ACH`, `Cash`, `Check`, `CreditCard`, `PayPal`, `WireTransfer`, `DebitCard`, `CreditCardReferenceTransaction`, `BankTransfer`, `Other`
- `number` (string, optional) — The unique identification number of the refund.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `paymentId` (string, optional, nullable) — The ID of the payment associated with the refund.
- `paymentMethodId` (string, optional) — The unique ID of the payment method that the customer used to make the refund.
- `paymentMethodSnapshotId` (string, optional) — The unique ID of the payment method snapshot, which is a copy of the particular payment method used in a transaction.
- `reasonCode` (string, optional, nullable) — A code identifying the reason for the transaction.
- `referenceId` (string, optional) — The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.
- `refundDate` (date, optional) — The date when the refund takes effect, in yyyy-mm-dd format.
- `refundTransactionTime` (string, optional) — The date and time when the refund was issued, in `yyyy-mm-dd hh:mm:ss` format.
- `secondRefundReferenceId` (string, optional, nullable) — The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments.
- `settledOn` (datetime, optional, nullable) — The date and time when the refund was settled in the payment processor, in `yyyy-mm-dd hh:mm:ss` format. This field is used by the Spectrum gateway only and not applicable to other gateways.
- `softDescriptor` (string, optional, nullable) — A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.
- `softDescriptorPhone` (string, optional, nullable) — A payment gateway-specific field that maps to Zuora for the gateways, Orbital, Vantiv and Verifi.
- `status` (enum, optional) — The status of the refund.
  - Allowed values: `Processed`, `Canceled`, `Error`, `Processing`
- `submittedOn` (string, optional) — The date and time when the refund was submitted, in `yyyy-mm-dd hh:mm:ss` format.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `type` (enum, optional) — The type of the refund.
  - Allowed values: `External`, `Electronic`
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the refund.
- `updatedDate` (string, optional) — The date and time when the refund was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-07 15:36:10.
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Origin__NS` (string, optional) — Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SynctoNetSuite__NS` (string, optional) — Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### CreditMemoFromChargeCustomRatesType

Container for custom fields of a Credit Memo Item object.

- `currency` (string, required) — The currency code for either Reporting or Home currency. **Note**: This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `224.0` or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version).
- `customFxRate` (double, required) — The Custom FX conversion rate between Home/Reporting and Transactional currency items. **Note**: This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `224.0` or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version).
- `rateDate` (date, optional) — The date on which a particular currency rate is fixed or obtained on. **Note**: This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `224.0` or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version).

### PostNonRefRefundTypeFinanceInformation

Container for the finance information related to the refund.

- `bankAccountAccountingCode` (string, optional) — The accounting code that maps to a bank account in your accounting system.
- `onAccountAccountingCode` (string, optional) — The accounting code that maps to an on account in your accounting system.
- `transferredToAccounting` (enum, optional) — Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `unappliedPaymentAccountingCode` (string, optional) — The accounting code for the unapplied payment.

### PostNonRefRefundTypeGatewayOptions

The field used to pass gateway-specific parameters and parameter values.

- `key` (string, optional) — The name of a gateway-specific parameter.
- `value` (string, optional) — The value of the gateway-specific parameter.

### RefundCreditMemoItemType

- `amount` (double, required) — The amount of the refund on the specific item.
- `creditMemoItemId` (string, optional) — The ID of the credit memo item that is refunded.
- `creditTaxItemId` (string, optional) — The ID of the credit memo taxation item that is refunded.

### GetRefundCreditMemoTypeFinanceInformation

Container for the finance information related to the refund.

- `bankAccountAccountingCode` (string, optional, nullable) — The accounting code that maps to a bank account in your accounting system.
- `bankAccountAccountingCodeType` (string, optional, nullable) — The type of the accounting code that maps to a bank account in your accounting system.
- `transferredToAccounting` (enum, optional, nullable) — Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `unappliedPaymentAccountingCode` (string, optional, nullable) — The accounting code for the unapplied payment.
- `unappliedPaymentAccountingCodeType` (string, optional, nullable) — The type of the accounting code for the unapplied payment.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "totalAmount": 10,
  "type": "Electronic",
  "paymentMethodId": "8ad084db90a5e73b0190c02783f552fa"
}
```

**Response**

```json
{
  "accountId": "8ad09be48db5aba7018db604776d4854",
  "amount": 10,
  "cancelledOn": null,
  "comment": null,
  "createdById": "b243314d594646d3b2651aeedd4be47e",
  "createdDate": "2024-07-25 00:19:43",
  "creditMemoId": "8ad0835290c4bb2f0190d9955e414e62",
  "financeInformation": {
    "bankAccountAccountingCode": null,
    "bankAccountAccountingCodeType": null,
    "transferredToAccounting": "No",
    "unappliedPaymentAccountingCode": "Accounts Receivable",
    "unappliedPaymentAccountingCodeType": "AccountsReceivable"
  },
  "gatewayId": "2c92c0f972bc6aa90172bc77ccaf379a",
  "gatewayResponse": "This transaction has been approved by Test gateway.",
  "gatewayResponseCode": "approve",
  "gatewayState": "Submitted",
  "id": "8ad0937890e7fca00190e8c290d46fad",
  "markedForSubmissionOn": null,
  "methodType": "CreditCard",
  "number": "R-00000001",
  "paymentId": null,
  "paymentMethodId": "8ad084db90a5e73b0190c02783f552fa",
  "paymentMethodSnapshotId": "8ad0937890e7fca00190e8c290b86fab",
  "reasonCode": null,
  "referenceId": "70028533",
  "refundDate": "2024-07-25",
  "refundTransactionTime": "2024-07-25 00:19:43",
  "secondRefundReferenceId": null,
  "settledOn": null,
  "softDescriptor": null,
  "softDescriptorPhone": null,
  "status": "Processed",
  "submittedOn": "2024-07-25 00:19:43",
  "success": true,
  "type": "Electronic",
  "updatedById": "b243314d594646d3b2651aeedd4be47e",
  "updatedDate": "2024-07-25 00:19:43",
  "gatewayReconciliationReason": null,
  "gatewayReconciliationStatus": null,
  "paymentGatewayNumber": null,
  "paymentNumber": null,
  "payoutId": null
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund"

payload = {
    "totalAmount": 10,
    "type": "Electronic",
    "paymentMethodId": "8ad084db90a5e73b0190c02783f552fa"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"totalAmount":10,"type":"Electronic","paymentMethodId":"8ad084db90a5e73b0190c02783f552fa"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund"

	payload := strings.NewReader("{\n  \"totalAmount\": 10,\n  \"type\": \"Electronic\",\n  \"paymentMethodId\": \"8ad084db90a5e73b0190c02783f552fa\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"totalAmount\": 10,\n  \"type\": \"Electronic\",\n  \"paymentMethodId\": \"8ad084db90a5e73b0190c02783f552fa\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"totalAmount\": 10,\n  \"type\": \"Electronic\",\n  \"paymentMethodId\": \"8ad084db90a5e73b0190c02783f552fa\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund', [
  'body' => '{
  "totalAmount": 10,
  "type": "Electronic",
  "paymentMethodId": "8ad084db90a5e73b0190c02783f552fa"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"totalAmount\": 10,\n  \"type\": \"Electronic\",\n  \"paymentMethodId\": \"8ad084db90a5e73b0190c02783f552fa\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "totalAmount": 10,
  "type": "Electronic",
  "paymentMethodId": "8ad084db90a5e73b0190c02783f552fa"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/credit-memos/creditMemoKey/refund")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```